unit ri;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls;

type
  TForm1 = class(TForm)
    Label1: TLabel;
    Label2: TLabel;
    Edit1: TEdit;
    Edit2: TEdit;
    Button1: TButton;
    Label5: TLabel;
    Label4: TLabel;
    procedure Button1Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

const n=20;dx=4;dy=4;
type mac=array[0..50] of real;
var
  Form1: TForm1;
  he, wi: integer;{   }
  a, b: real;{  }

implementation
{$R *.dfm}

procedure Znach(x,y,h:integer;angle:real;s:string);
var
  LogRec: TLOGFONT; //   
begin
  with form1.canvas do
  begin
    Font.Name:='Times New Roman';Font.Size:=h;
    //     
    GetObject (Font.Handle ,SizeOf(LogRec) ,Addr(LogRec));
    //  
    LogRec.lfEscapement:=round(angle*10);
    //   
    Font.Handle := CreateFontIndirect(LogRec);
    TextOut(x,y,s);
  end;
end;

function f(x:real):real;
begin
  f:=sin(x);
end;

procedure TForm1.Button1Click(Sender: TObject);
var
  xmin, xmax: real; {  }
  ymin, ymax: real; {   }
  xos, yos: real;   {      }
  xm, ym: real;     {      }
  mxd, myd: real;   {    
                      }
  mx, my: real;     { }
  gy, i, x1, y1, mx1, my1, jj: integer;
  x, y: mac;
  h: real;
  s: string;

  procedure border(var x,y:mac;var Xmin,Xmax,Ymin,Ymax:real;
  var xm, ym, mxd, myd, mx, my: real);
  var h, r: real;
      i, m: integer;
      s: string;
  begin
    h:=(b-a)/N;{ }
    xMax:=-9999;Xmin:=-Xmax;ymax:=xmax;Ymin:=Xmin;
    for i:=0 to N do begin
      xm:=a+i*h;ym:=f(xm); Y[i]:=ym;X[i]:=xm;
      if xm<Xmin then xMin:=xm;
      if xm>Xmax then xMax:=xm;
      if ym<Ymin then yMin:=ym;
      if ym>Ymax then yMax:=ym;
    end;
    xm:=abs(xmin);if abs(xmax)>xm then xm:=abs(xmax);
    ym:=abs(ymin);if abs(ymax)>ym then ym:=abs(ymax);
    m:=0;mx:=1;
    if xm>10 then begin
      while xm*mx>10 do begin
        mx:=mx*0.1;inc(m);
      end;
      mx:=mx*10;dec(m);
    end
    else begin
      while xm*mx<1 do begin
        mx:=mx*10;dec(m);
      end;
    end;
    my:=1;
    if ym>10 then begin
      while ym*my>10 do my:=my*0.1;
      my:=my*10;
    end
    else begin
      while ym*my<1 do my:=my*10;
    end;
    for i:=0 to N do begin
      x[i]:=x[i]*mx;y[i]:=y[i]*my;
    end;
    xmin:=xmin*mx;xmax:=mx*xmax;
    ymin:=ymin*my;ymax:=my*ymax;
    xm:=Xmax-Xmin;ym:=yMax-yMin;
    mxd:=xm+0.2*xm;myd:=ym+0.2*ym;
    xm:=xMin-0.1*xm;ym:=yMin-0.1*ym;
    r:=exp(m*ln(10));
    if r<1 then str(r:10:5,s) else str(r:10:0,s);
    label4.caption:='X:'+s;
    if my<1 then str(my:10:5,s) else str(my:10:0,s);
    Label5.Caption:='Y: '+s;
  end;

  { (,)   }
  procedure ScreenCoord (XR, YR: Real;
  var x1, y1: integer);
  begin
    x1:= Trunc((XR - xm)*XOS);
    y1:= Gy - Trunc((YR - yM)*YOS);
  end;

  procedure Xdelen(var i:integer);
  var s: string;
      x1, y1: integer;
  begin
    with form1.Canvas do begin
      ScreenCoord (i, 0, x1, y1 );
      Moveto(x1,y1-3);LineTo(x1,y1+3);
      if not(odd(i))and(i<>0) then begin
         str(i:5,s);textOut(x1-3*dx-1,y1+dy,s);
      end;
    end;
  end;

  procedure Ydelen(var i:integer);
  var s: string;
  x1, y1: integer;
  begin
    with canvas do begin
      ScreenCoord (0, i, x1, y1);
      MoveTo(x1-3,y1);LineTo(x1+3,y1);
      if not(odd(i))and(i<>0) then begin
         str(i:5,s);textOut(x1+2,y1,s);
      end;
    end;
  end;

begin
  he:=form1.height;wi:=form1.width;
  canvas.Refresh;
  a:=strtofloat(edit1.text);
  b:=strtofloat(edit2.text);

  {     
  ,    }
  border(x,y,xmin,xmax,ymin,ymax,xm,ym,mxd,myd,mx,my);

  {  }
  xos:=he/mxd;Gy:=wi div 2;yos:=gy/myd;

  { :}
  {-  }
  with form1.Canvas do begin
    ScreenCoord (xmin, 0, x1, y1 );Moveto(x1,y1);
    ScreenCoord (xmax, 0, x1, y1 );Lineto(x1+3*dx,y1);
  end;

  { }
  with form1.Canvas do begin
    Moveto(x1+3*dx,y1);Lineto(x1+2*dx,y1-dy);
    Moveto(x1+3*dx,y1);Lineto(x1+2*dx,y1+dy);
    Textout(x1+3*dx,y1-3*dy,'x');
  end;

  {    X}
  for i:=trunc(xmin) to trunc(xmax) do Xdelen(i);
  {-  }
  with form1.Canvas do begin
    ScreenCoord (0, ymin, x1, y1);MoveTo(x1,y1);
    ScreenCoord (0, ymax, x1, y1);LineTo(x1,y1-2*dy);
  end;

  { y}
  form1.Canvas.MoveTo(x1,y1-2*dy);
  form1.canvas.Lineto(x1-dx,y1-dy);
  form1.canvas.Moveto(x1,y1-2*dy);
  form1.canvas.Lineto(x1+dx,y1-dy);
  form1.canvas.Textout(x1+dx,y1-3*dy,'y');
  {    Y}
  for i:=trunc(ymin) to trunc(ymax) do Ydelen(i);
  { }
  ScreenCoord (x[0], y[0], x1, y1);
  form1.Canvas.moveto(x1,y1);
  for i:=1 to N do
  begin
    ScreenCoord (x[i], y[i], x1, y1);form1.Canvas.Lineto(x1,y1);
  end;
  ScreenCoord (x[N-2], y[N-2], x1, y1);form1.Canvas.moveto(x1,y1);
  znach(x1,y1,12,30,'y=sin(x)');
end;

end.


